<?php

namespace Aviatoo\Rest\ORM;


use Aviatoo\Rest\Repository\Pagination;

class QueryBuilder extends \Doctrine\ORM\QueryBuilder
{
    protected $pagination,$lastGroupBy;

    /**
     * @param Pagination $pagination
     * @return \Doctrine\ORM\QueryBuilder
     */
    public function setPagination(Pagination $pagination){
        $this->pagination = $pagination;
        return $this->setMaxResults($pagination->getLimit())
            ->setFirstResult($pagination->getOffset());
    }

    /**
     * @return $this
     */
    public function unsetPagination(){
        $this->pagination = null;
        return $this;
    }
    /**
     * @return Pagination
     */
    public function getPagination()
    {
        return $this->pagination;
    }

    /**
     * @param string $groupBy
     * @return QueryBuilder
     */
    public function groupBy($groupBy)
    {
        $this->lastGroupBy = $groupBy;
        return parent::groupBy($groupBy); // TODO: Change the autogenerated stub
    }

    /**
     * @param string $groupBy
     * @return QueryBuilder
     */
    public function addGroupBy($groupBy)
    {
        $this->lastGroupBy = $groupBy;
        return parent::addGroupBy($groupBy); // TODO: Change the autogenerated stub
    }

    /**
     * @return mixed
     */
    public function getLastGroupBy(){
        return $this->lastGroupBy? $this->lastGroupBy : $this->getRootAliases()[0];
    }

    /**
     * @return \Doctrine\ORM\Query
     */
    public function getQuery()
    {
        $pagination = $this->getPagination();
        if($pagination && $pagination->getOffset() == 0){
            $paginationQuery = clone $this;
            $lastGroupBy = $this->getLastGroupBy();
            $count = $paginationQuery
                ->select("COUNT(DISTINCT $lastGroupBy) as count")
                ->setFirstResult(0)
                ->resetDQLPart("groupBy")
                ->resetDQLPart("orderBy")
                ->unsetPagination(null)
                ->getQuery()
                ->getOneOrNullResult();

            if($count) Pagination::setPages(intval(ceil($count["count"]/$pagination->getPageSize())));

        }
        return parent::getQuery(); // TODO: Change the autogenerated stub
    }


}